/*
 * <aisl/config.h>
 *
 * Copyright (c) 2017-2019 by Löwenware Ltd.
 *
 * Project homepage: https://lowenware.com/aisl/
 *
 */

#ifndef AISL_CONFIG_H_DB67A89B_5CAF_4A5F_AEB1_6DB9F84827D6
#define AISL_CONFIG_H_DB67A89B_5CAF_4A5F_AEB1_6DB9F84827D6

#include <aisl/types.h>

#define AISL_CFG_DEFAULT            \
{                                   \
    .callback               = NULL  \
  , .p_ctx                  = NULL  \
  , .srv                    = NULL  \
  , .ssl                    = NULL  \
  , .srv_cnt                = 0     \
  , .ssl_cnt                = 0     \
  , .client_spool_size      = 32    \
  , .initial_buffer_size    = 16536 \
  , .client_accept_limit    = 1024  \
  , .client_silence_timeout = 30    \
}                                   \


struct aisl_cfg_srv
{
  const char * host;
  uint16_t     port;
  bool         secure;
};

typedef struct aisl_cfg_srv * aisl_cfg_srv_t;


struct aisl_cfg_ssl
{
  const char * host;
  const char * key_file;
  const char * crt_file;
};

typedef struct aisl_cfg_ssl * aisl_cfg_ssl_t;


struct aisl_cfg
{
  /* event handlers */
  aisl_callback_t callback;
  void          * p_ctx;

  aisl_cfg_srv_t srv;
  aisl_cfg_ssl_t ssl;

  int srv_cnt;
  int ssl_cnt;

  int client_spool_size;
  int initial_buffer_size;
  int client_accept_limit;
  int client_silence_timeout;
};

typedef struct aisl_cfg * aisl_cfg_t;

#endif /* !AISL_CONFIG_H */
